$TP::Version=1.1; //Version number, do NOT change this unless you know what you are doing.

if ($Support::MLRSshootOnClick<$Prop::Version)
{
	return;   //Newer version already loaded.
}
$Support::MLRSshootOnClick=$TP::Version;

package MLRSshootOnClick_Pack
{
	function armor::onTrigger(%db,%obj,%slot,%val)
	{
		if (%obj.getObjectmount() == 0)
			return Parent::onTrigger(%db,%obj,%slot,%val);

		if (%obj.getObjectmount().getDatablock() == MLRSVehicle.getID())
		{

			if (%obj.getClassName()$="Player")
			{

				if (%slot==0)
				{
					if (%val)
					{

						if($Sim::Time<%obj.client.MLRSSOC_LastFireTime)
						{
							return;
						}

					}

					%obj.MLRSSOC_Shoot(%slot,%val,0);

				}

			}

		}
		return Parent::onTrigger(%db,%obj,%slot,%val);
	}

};
ActivatePackage(MLRSshootOnClick_Pack);

function repeatedVectorAddwithScale(%vecs)
{
	%vec="0 0 0";
	%cnt=getFieldCount(%vecs);
	for (%i=0; %i<%cnt; %i++)
	{
		%fld=getField(%vecs,%i);
		%tvec=getWords(%fld,0,3);
		%scale=getWord(%fld,3);
		%svec=vectorScale(%tvec,%scale);
		%vec=vectorAdd(%vec,%svec);
	}
	return %vec;
}

function SimObject::getLeftVector(%obj)
{
	return vectorCross(%obj.getEyeVector(),%obj.getUpVector());
}

function SimObject::getRightVector(%obj)
{
	return vectorScale(%obj.getLeftVector(%obj),-1);
}
function MLRSVehicle::onReload(%this,%obj)
{
	if(!isobject(%obj))
		return;
	%obj.ammo[0]=%obj.getDatablock().MLRSshootOnClick_Ammo[0];
	%obj.reloading=false;
}

function Player::MLRSSOC_Shoot(%obj,%slot,%val,%dir)
{

	if (%dir == 1)
	{
		%val=1;
	}

	if (!%val)
	{
		cancel(%obj.MLRSSOC_reshoot);
		return;
	}
	%mnt= %obj.getObjectMount();

	if (!isObject(%mnt))
	{
		return;
	}

	%data= %mnt.getDatablock();

	%mountObj= %mnt.getMountNodeObject(%data.MLRSshootOnClick_RequiredSlot[%dir]);
	if (%mountObj!$=%Obj || !%mnt.saveLock)
	{
		return;
	}


	if (%data.MLRSShootOnClick)
	{

		if (%mnt.getDatablock() == MLRSVehicle.getID())
		{
			if(%mnt.ammo[0] == 0)
			{	if (!%mnt.reloading) {
					%obj.reload = %data.schedule(%data.MLRSshootOnClick_Reloadtime[0],"onReload",%mnt);
					%mnt.reloading=true;
				}
				return;
			} 
			else
			{
				%mnt.ammo[0]--;
			}

			%cnt = %data.MLRSshootOnClick_ProjectileCount[%dir];
			for (%i=0; %i<%cnt; %i++)
			{
				%turret = %mnt.turret;
				%player = %mnt.getMountNodeObject(0);
				%pos = %mnt.turret.getEyeTransform();
				//%pos = %player.getEyeTransform();
				%PVec= %data.MLRSshootOnClick_Position[%dir,%i];
				%VVec= %data.MLRSshootOnClick_Velocity[%dir,%i];
				%fVec= %data.MLRSshootOnClick_flashVelocity[%dir,%i];
				
				%gap = 0;
				if ((%mnt.ammo[0] % 12) < 6) {
					if ((%mnt.ammo[0] % 12) <= 2)
						%gap = 1.5;
					%pVec = vectorScale(vectorSub(%pVec,0 SPC (%mnt.ammo[0] % 12) - 6 - %gap SPC 0),0.7);
				}
				else {
					if ((%mnt.ammo[0] % 12) <= 8)
						%gap = 1.5;
					%pVec = vectorScale(vectorSub(%pVec,0 SPC (%mnt.ammo[0] % 12) - 12 - %gap SPC -0.8),0.7);
				}

				%iPos= repeatedVectorAddwithScale(
				           %turret.getEyeVector() SPC getWord(%PVec,0) TAB
				           %turret.getLeftVector() SPC getWord(%PVec,1) TAB
				           %turret.getUpVector() SPC getWord(%PVec,2)
				       );
				%iVel= repeatedVectorAddwithScale(
				           %turret.getEyeVector() SPC getWord(%VVec,0) TAB
				           %turret.getLeftVector() SPC getWord(%VVec,1) TAB
				           %turret.getUpVector() SPC getWord(%VVec,2)
				       );
				%fVel= repeatedVectorAddwithScale(
				           %turret.getEyeVector() SPC getWord(%fVec,0) TAB
				           %turret.getLeftVector() SPC getWord(%fVec,1) TAB
				           %turret.getUpVector() SPC getWord(%fVec,2)
				       );
				%scale=%data.MLRSshootOnClick_Scale[%dir,%i];
				if (%scale$="")
				{
					%scale="1 1 1";
				}
				%spread = %data.MLRSshootOnClick_Spread[%dir,%i];
				%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
				%velocity = MatrixMulVector(%mat, %iVel);
				serverPlay3d("MLRSFire" @ getRandom(1,3) @ "Sound",%pos);

				%p= new Projectile()
				{
					dataBlock= %data.MLRSshootOnClick_Projectile[%dir,%i];
					initialPosition= vectorAdd(%pos,%iPos);
					initialVelocity= %velocity;
					sourceObject= %obj;
					client= %obj.client;
					sourceSlot= %slot;
					scale= %scale;
				};
	
				missionCleanup.add(%p);

				if (%dir == 0) {
					%tank = %mnt.getObjectMount();

					%theVector = vectorAdd(%mnt.turret.getEyeVector(),"0 0 -1");
					%theVector = vectorScale(%theVector,600);
					%theVector = vectorSub(%theVector,vectorScale(%thevector,2));

					// %mnt.applyImpulse(getWords(%mnt.turret.getEyeTransform(),0,2),%theVector);
					%mnt.turret.playthread(0,"fire");
					%s = new Projectile()
					{
						dataBlock = %data.MLRSshootOnClick_FlashProjectile[%dir];
						initialPosition = vectorAdd(%pos,%iPos);
						initialVelocity = %fVel;
						client = %obj.client;
						sourceObject= %obj;

						sourceSlot= %slot;
						scale= %scale;

					};
					MissionCleanup.add(%s);
					if (%data.MLRSshootOnClick_Hold[%dir] && !mnt.reloading)
					{
						%obj.MLRSSOC_reshoot= %obj.schedule(%data.MLRSshootOnClick_ReshootDelay[%dir],MLRSSOC_Shoot,%slot,%val,0);
					}
					%obj.client.MLRSSOC_LastFireTime=$Sim::Time+%data.MLRSshootOnClick_ShootDelay[%dir]/1000;

				}
					

				

			}

			

		}
	}

}