datablock AudioProfile(MLRSFire1Sound)
{
	filename    = "./sounds/MissileShoot_1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(MLRSFire2Sound : MLRSFire1Sound)
{
	filename    = "./sounds/MissileShoot_2.wav";
};
datablock AudioProfile(MLRSFire3Sound : MLRSFire1Sound)
{
	filename    = "./sounds/MissileShoot_3.wav";
};

datablock TSShapeConstructor(MLRSTurretDts)
{
	baseShape = "./shapes/MLRSTurret.dts";
	sequence0 = "./shapes/MLRS_root.dsq root";
	sequence1 = "./shapes/MLRS_root.dsq run";
	sequence2 = "./shapes/MLRS_root.dsq walk";
	sequence3 = "./shapes/MLRS_root.dsq back";
	sequence4 = "./shapes/MLRS_root.dsq side";
	sequence5 = "./shapes/MLRS_root.dsq crouch";
	sequence6 = "./shapes/MLRS_root.dsq crouchRun";
	sequence7 = "./shapes/MLRS_root.dsq crouchBack";
	sequence8 = "./shapes/MLRS_root.dsq crouchSide";
	sequence9 = "./shapes/MLRS_look.dsq look";
	sequence10 = "./shapes/MLRS_root.dsq headside";
	sequence11 = "./shapes/MLRS_root.dsq headUp";
	sequence12 = "./shapes/MLRS_root.dsq jump";
	sequence13 = "./shapes/MLRS_root.dsq standjump";
	sequence14 = "./shapes/MLRS_root.dsq fall";
	sequence15 = "./shapes/MLRS_root.dsq land";
	sequence16 = "./shapes/MLRS_root.dsq armAttack";
	sequence17 = "./shapes/MLRS_root.dsq armReadyLeft";
	sequence18 = "./shapes/MLRS_root.dsq armReadyRight";
	sequence19 = "./shapes/MLRS_root.dsq armReadyBoth";
	sequence20 = "./shapes/MLRS_root.dsq spearready";
	sequence21 = "./shapes/MLRS_root.dsq spearThrow";
	sequence22 = "./shapes/MLRS_root.dsq talk";
	sequence23 = "./shapes/MLRS_root.dsq death1";
	sequence24 = "./shapes/MLRS_root.dsq shiftUp";
	sequence25 = "./shapes/MLRS_root.dsq shiftDown";
	sequence26 = "./shapes/MLRS_root.dsq shiftAway";
	sequence27 = "./shapes/MLRS_root.dsq shiftTo";
	sequence28 = "./shapes/MLRS_root.dsq shiftLeft";
	sequence29 = "./shapes/MLRS_root.dsq shiftRight";
	sequence30 = "./shapes/MLRS_root.dsq rotCW";
	sequence31 = "./shapes/MLRS_root.dsq rotCCW";
	sequence32 = "./shapes/MLRS_root.dsq undo";
	sequence33 = "./shapes/MLRS_root.dsq plant";
	sequence34 = "./shapes/MLRS_root.dsq sit";
	sequence35 = "./shapes/MLRS_root.dsq wrench";
};

datablock ParticleData(MLRSTireParticle)
{
	dragCoefficient = 8;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 500;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10;
	spinRandomMin = -50;
	spinRandomMax = 50;
	colors[0] = "0.4 0.4 0.4 0.3";
	colors[1] = "0.2 0.2 0.2 0";
	sizes[0] = 2;
	sizes[1] = 6;
	useInvAlpha = true;
};

datablock ParticleEmitterData(MLRSTireEmitter)
{
	uiName = "";
	ejectionPeriodMS = 50;
	periodVarianceMS = 25;
	ejectionVelocity = 2;
	velocityVariance = 1;
	ejectionOffset = 0;
	thetaMin = 89;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "MLRSTireParticle";
	useEmitterColors = true;
};

// Gun fire projectile
datablock ParticleData(MLRSFireParticle)
{
	dragCoefficient = 5;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.3;
	constantAcceleration = 0;
	lifetimeMS = 300;
	lifetimeVarianceMS = 200;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10;
	spinRandomMin = -50;
	spinRandomMax = 50;
	colors[0] = "1 0.2 0.2 0.5";
	colors[1] = "0.5 0.5 0.5 0.1";
	colors[2] = "0.3 0.3 0.3 0.3";
	sizes[0] = 1;
	sizes[1] = 7;
	sizes[2] = 8;
	times[0] = 0;
	times[1] = 0.3;
	times[2] = 1;
	useInvAlpha = false;
};

datablock ParticleEmitterData(MLRSFireEmitter)
{
	uiName = "";
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = 30;
	velocityVariance = 0;
	ejectionOffset = 3;
	thetaMin = 0;
	thetaMax = 20;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "MLRSFireParticle";
};

datablock ProjectileData(MLRSFireProjectile)
{
	directDamage        = 0;
	radiusDamage        = 0;
	damageRadius        = 0;
	muzzleVelocity      = 40;
	particleEmitter     = MLRSFireEmitter;
	directDamageType  = $DamageType::jeepExplosion;
	radiusDamageType  = $DamageType::jeepExplosion;

	explodeOnDeath       = 0;

	armingDelay         = 0;
	lifetime            = 150;
};



datablock ParticleData(MLRSTrailParticle)
{
   dragCoefficient      = 10;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin     = -500.0;
   spinRandomMax     = 500.0;

   colors[0]     = (238/255) SPC (154/255) SPC (73/255) SPC (10/255);
   colors[1]     = (255/255) SPC (255/255) SPC (255/255) SPC (255/255);
   colors[2]     = (200/255) SPC (200/255) SPC (200/255) SPC (100/255);
   colors[3]     = (255/255) SPC (255/255) SPC (255/255) SPC (1/255);

   sizes[0]      = 1;
   sizes[1]      = 1.1;
   sizes[2]      = 0.8;
   sizes[3]      = 0.6;

   times[0] = 0;
   times[1] = 0.01;
   times[2] = 0.011;
   times[3] = 1.0;
   useInvAlpha = true;
};
datablock ParticleEmitterData(MLRSTrailEmitter)
{
ejectionPeriodMS =2;
   periodVarianceMS = 0;
   ejectionVelocity = 30.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 15;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
	particles = "MLRSTrailParticle";
};

datablock ParticleData(MLRSRocketExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.1 0.1 0.1 0.9";
	colors[1]     = "0.1 0.1 0.1 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(MLRSRocketExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MLRSRocketExplosionParticle";

   emitterNode = TenthEmitterNode;
};


datablock ParticleData(MLRSRocketExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0.2 0.5";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 8;
	sizes[1]      = 13;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MLRSRocketExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MLRSRocketExplosionRingParticle";

};

datablock ParticleData(MLRSExplosionDebrisParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 805;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.0 0.4";
	colors[1]     = "1.0 0.2 0.0 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 1;
	sizes[1]      = 0.85;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MLRSExplosionDebrisEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MLRSExplosionDebrisParticle";

};

datablock DebrisData(MLRSShellDebris)
{
   emitters = "MLRSExplosionDebrisEmitter";

	shapeFile = "./emptywheel.dts";
	lifetime = 0.3;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.4;
	numBounces = 0;
	staticOnMaxBounce = false;
	snapOnMaxBounce = true;
	fade = false;

	gravModifier = 10;
};

datablock ExplosionData(MLRSShellExplosion)
{
	explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   debris = MLRSShellDebris;
   debrisNum = 30;
   debrisNumVariance = 10;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 30;
   debrisVelocityVariance = 50;

   particleEmitter = MLRSRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = MLRSRocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";


   playerBurnTime = 5000;

	impulseForce = 500;
	impulseRadius = 15;
	damageRadius = 20;
	radiusDamage = 25;
};
AddDamageType("MLRSCannon",   '<color:FFFF00>[M270 MLRS]<color:FF0000> %1',    '%2 <color:FFFF00>[M270 MLRS]<color:FF0000> %1',0.2,1);
datablock ProjectileData(MLRSCannonStage1Projectile)
{
	projectileShapeName = "./shapes/javelinRocket2.dts";
	directDamage        = 200;

	directDamageType    = $DamageType::MLRSCannon;
	radiusDamageType    = $DamageType::MLRSCannon;

	brickExplosionRadius = 0;
	brickExplosionImpact = true;          //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	impactImpulse         = 0;
	verticalImpulse    = 0;
	explosion           = MLRSShellExplosion;
	particleEmitter     = MLRSTrailEmitter;

	muzzleVelocity      = 80;
	velInheritFactor    = 1;

	armingDelay         = 00;
	lifetime            = 100000;
	fadeDelay           = 000;
	bounceElasticity    = 0.2;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 1;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
	damageRadius = 20;
	radiusDamage = 200;
};
datablock ProjectileData(MLRSCannonStage2Projectile : MLRSCannonStage1Projectile)
{
	projectileShapeName = "./shapes/javelinRocket2.dts";
	directDamage        = 200;

	directDamageType    = $DamageType::MLRSCannon;
	radiusDamageType    = $DamageType::MLRSCannon;

	brickExplosionRadius = 0;
	brickExplosionImpact = true;          //destroy a brick if we hit it directly?
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	impactImpulse         = 0;
	verticalImpulse    = 0;
	explosion           = MLRSShellExplosion;
	particleEmitter     = "";


	muzzleVelocity      = 80;
	velInheritFactor    = 1;

	armingDelay         = 00;
	lifetime            = 100000;
	fadeDelay           = 000;
	bounceElasticity    = 0.2;
	bounceFriction      = 0.20;
	isBallistic         = true;
	gravityMod = 1;

	hasLight    = false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";
	damageRadius = 20;
	radiusDamage = 200;
};
datablock ShapeBaseImageData(MLRSFrontTireStop)
{
	shapeFile = "./shapes/mlrsWheels.dts";
	emap = false;

	mountPoint = 2;
	rotation = "0 1 0 0";

	stateName[0]               = "Ready";
	stateTransitionOnTimeout[0]      = "FireA";
	stateTimeoutValue[0]       = 0.01;

	stateName[1]               = "FireA";
	stateTransitionOnTimeout[1]      = "FireE";
	stateWaitForTimeout[1]        = true;
	stateSequence[1]           = "prop";
	stateTimeoutValue[1]       = 0.2;

	stateName[2]               = "FireE";
	stateTransitionOnTimeout[2]      = "FireA";
	stateWaitForTimeout[2]        = true;
	stateSequence[2]           = "prop";
	stateTimeoutValue[2]       = 0.2;

};
datablock ShapeBaseImageData(MLRSFrontTire)
{
	shapeFile = "./shapes/mlrsWheels.dts";
	emap = false;

	mountPoint = 2;
	rotation = "0 1 0 0";

	stateName[0]               = "Ready";
	stateTransitionOnTimeout[0]      = "FireA";
	stateTimeoutValue[0]       = 0.01;

	stateName[1]               = "FireA";
	stateTransitionOnTimeout[1]      = "FireE";
	stateWaitForTimeout[1]        = true;
	stateSequence[1]           = "wheelSpin";
	stateTimeoutValue[1]       = 0.2;

	stateName[2]               = "FireE";
	stateTransitionOnTimeout[2]      = "FireA";
	stateWaitForTimeout[2]        = true;
	stateSequence[2]           = "wheelSpin";
	stateTimeoutValue[2]       = 0.2;

};
datablock PlayerData(MLRSTurretPlayer)
{
	renderFirstPerson = true;
	emap = false;

	className = Armor;
	shapeFile = "./shapes/MLRSTurret.dts";
	useEyePoint = false;
	cameraMaxDist = 24;
	cameraTilt = 0.0;
	cameraVerticalOffset = 2.3;

	cameraDefaultFov = 90.0;
	cameraMinFov = 5.0;
	cameraMaxFov = 120.0;

	//debrisShapeName = "~/data/player/debris_player.dts";
	//debris = horseDebris;

	aiAvoidThis = false;

	minLookAngle = -$pi;
	maxLookAngle = 1;
	maxFreelookAngle = 1.0;

	mass = 200000;
	drag = 1;
	density = 5;
	maxDamage = 400;
	maxEnergy =  10;
	repairRate = 0.33;

	rechargeRate = 0.4;

	runForce = 1000;
	runEnergyDrain   = 0;
	minRunEnergy     = 0;
	maxForwardSpeed  = 0;
	maxBackwardSpeed = 0;
	maxSideSpeed     = 0;

	maxForwardCrouchSpeed  = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideCrouchSpeed     = 0;

	maxUnderwaterForwardSpeed  = 0;
	maxUnderwaterBackwardSpeed = 0;
	maxUnderwaterSideSpeed     = 0;

	jumpForce       = 0;
	jumpEnergyDrain = 0;
	minJumpEnergy   = 0;
	jumpDelay       = 0;

	minJetEnergy   = 0;
	jetEnergyDrain = 0;
	canJet         = 0;

	minImpactSpeed   = 250;
	speedDamageScale = 3.8;

	boundingBox = vectorScale("4.2 4.2 1.2",4);
	crouchBoundingBox = vectorScale("4.2 4.2 1.2",4);

	pickupRadius = 0.75;

	// Foot Prints
	//decalData   = HorseFootprint;
	//decalOffset = 0.25;

	jetEmitter        = "";
	jetGroundEmitter  = "";
	jetGroundDistance = 4;

	//footPuffEmitter = LightPuffEmitter;
	footPuffNumParts = 10;
	footPuffRadius = 0.25;

	//dustEmitter = LiftoffDustEmitter;

	splash = PlayerSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 0.1;
	splashEmitter[0] = PlayerFoamDropletsEmitter;
	splashEmitter[1] = PlayerFoamEmitter;
	splashEmitter[2] = PlayerBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	exitSplashSoundVelocity = 5.0;

	// Controls over slope of runnable/jumpable surfaces
	runSurfaceAngle  = 85;
	jumpSurfaceAngle = 86;

	minJumpSpeed = 20;
	maxJumpSpeed = 30;

	horizMaxSpeed = 68;
	horizResistSpeed = 33;
	horizResistFactor = 0.35;

	upMaxSpeed = 80;
	upResistSpeed = 25;
	upResistFactor = 0.3;

	footstepSplashHeight = 0.35;

	//NOTE:  some sounds commented out until wav's are available

	JumpSound = "";

	groundImpactMinSpeed    = 10.0;
	groundImpactShakeFreq   = "4.0 4.0 4.0";
	groundImpactShakeAmp    = "1.0 1.0 1.0";
	groundImpactShakeDuration = 0.8;
	groundImpactShakeFalloff = 10.0;

	//exitingWater         = ExitingWaterLightSound;

	// Inventory Items
	maxItems   = 10; //total number of bricks you can carry
	maxWeapons = 5;      //this will be controlled by mini-game code
	maxTools = 5;

	rideable = true;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;    //the imageData to use for brick deployment

	numMountPoints = 1;
	mountThread[0] = "root";

	//protection for passengers
	protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
	protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
	protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?

	useCustomPainEffects = true;
	PainHighImage = "";
	PainMidImage  = "";
	PainLowImage  = "";
	painSound     = "";
	deathSound    = "";





};

datablock WheeledVehicleTire(MLRSTire)
{
	// Tires act as springs and generate lateral and longitudinal
	// forces to move the vehicle. These distortion/spring forces
	// are what convert wheel angular velocity into forces that
	// act on the rigid body.
	shapeFile = "./shapes/emptyWheel.dts";

	mass = 10;
	radius = 0.8;
	staticFriction = 5;
	kineticFriction = 5;
	restitution = 0.5;

	lateralForce = 180000;
	lateralDamping = 4000;
	lateralRelaxation = 0.01;

	longitudinalForce = 18000;
	longitudinalDamping = 4000;
	longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(MLRSSpring)
{
	// Wheel suspension properties
	length = 0.8;        // Suspension travel
	force = 7000;        // Spring force
	damping = 1000;      // Spring damping
	antiSwayForce = 6;   // Lateral anti-sway force
};


datablock WheeledVehicleData(MLRSVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./shapes/mlrs.dts";
	emap = true;
	minMountDist = 3;

	numMountPoints = 1;
	mountThread[0] = "root";


	maxDamage = 200.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0.5";
	//massBox = "2 5 1";

	maxSteeringAngle = 1;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = MLRSTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 20;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.0;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = false;

	defaultTire = MLRSTire;
	defaultSpring   = MLRSSpring;

	numWheels = 6;

	// Rigid Body
	mass = 500;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 4000;
	engineBrake = 4000;
	brakeTorque = 5000;
	maxWheelSpeed = 25;
	rollForce = 10;
	yawForce = 60;
	pitchForce = 100;
	rotationalDrag = 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	exitSplashSoundVelocity = 5.0;

	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";

	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = rocketLoopSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

	uiName = "M270 MLRS";
	rideable = true;
	//lookUpLimit = 0.9;
	//lookDownLimit = 0.1;
	lookUpLimit  = 0.5;
	lookDownLimit = 0.5;

	paintable = true;

	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 -4 0.0 ";
	damageLevelTolerance[0] = 0.75;


	numDmgEmitterAreas = 1;

	initialExplosionProjectile = tankExplosionProjectile;
	initialExplosionOffset = 1;         //offset only uses a z value for now

	burnTime = 4000;

	finalExplosionProjectile = tankFinalExplosionProjectile;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now


	minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 25;   //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

	//protection for passengers
	protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
	protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
	protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?

	steeringUseStrafeSteering = 1;

	MLRSShootOnClick=1;

	MLRSShootOnClick_Hold[0] = 1;
	MLRSShootOnClick_ShootDelay[0] = 300;
	MLRSShootOnClick_ReShootDelay[0] = 300;
	MLRSShootOnClick_ProjectileCount[0] = 1;
	MLRSShootOnClick_RequiredSlot[0] = 0;
	MLRSShootOnClick_Sound[0] = MLRSCannonfireSound;
	MLRSShootOnClick_fromSlot[0] = 0;
	MLRSShootOnClick_useEye[0] = 1;
	MLRSShootOnClick_Ammo[0] = "12";
	MLRSshootOnClick_FlashProjectile [0] = MLRSFireProjectile;
	MLRSshootOnClick_Reloadtime[0] = 10000;

	MLRSshootOnClick_Spread[0,0] = 0.0015;
	MLRSShootOnClick_Projectile[0,0] = MLRSCannonStage1Projectile;
	MLRSShootOnClick_Position[0,0] = "0 -4.5 -0.1";//4
	MLRSShootOnClick_Velocity[0,0] = MLRSCannonStage1Projectile.muzzleVelocity SPC "0 0";
	MLRSShootOnClick_Scale[0,0] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[0,0] = "-200 0 0";

	MLRSShootOnClick_Hold[1] = 0;
	MLRSShootOnClick_ShootDelay[1] = 10000;
	MLRSShootOnClick_ReShootDelay[1] = 10000;
	MLRSShootOnClick_ProjectileCount[1] = 6;
	MLRSShootOnClick_RequiredSlot[1] = 0;
	MLRSShootOnClick_fromSlot[1] = 0;
	MLRSShootOnClick_useEye[1] = 0;
	MLRSShootOnClick_Sound[1] = MLRSSmokeFireSound;
	MLRSshootOnClick_FlashProjectile [1] = "";

	MLRSshootOnClick_Spread[1,0] = 0.0;
	MLRSShootOnClick_Projectile[1,0] = MLRSSmokeProjectile;
	MLRSShootOnClick_Position[1,0] = "1 3 2";//4
	MLRSShootOnClick_Velocity[1,0] = "20 0 8";
	MLRSShootOnClick_Scale[1,0] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[1,0] = "0 0 0";

	MLRSshootOnClick_Spread[1,1] = 0.0;
	MLRSShootOnClick_Projectile[1,1] = MLRSSmokeProjectile;
	MLRSShootOnClick_Position[1,1] = "1 3 2";//4
	MLRSShootOnClick_Velocity[1,1] = "10 10 8";
	MLRSShootOnClick_Scale[1,1] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[1,1] = "0 0 0";

	MLRSshootOnClick_Spread[1,2] = 0.0;
	MLRSShootOnClick_Projectile[1,2] = MLRSSmokeProjectile;
	MLRSShootOnClick_Position[1,2] = "1 3 2";//4
	MLRSShootOnClick_Velocity[1,2] = "0 18 8";
	MLRSShootOnClick_Scale[1,2] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[1,2] = "0 0 0";

	MLRSshootOnClick_Spread[1,3] = 0.0;
	MLRSShootOnClick_Projectile[1,3] = MLRSSmokeProjectile;
	MLRSShootOnClick_Position[1,3] = "1 -3 2";//4
	MLRSShootOnClick_Velocity[1,3] = "20 -5 8";
	MLRSShootOnClick_Scale[1,3] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[1,3] = "0 0 0";

	MLRSshootOnClick_Spread[1,4] = 0.0;
	MLRSShootOnClick_Projectile[1,4] = MLRSSmokeProjectile;
	MLRSShootOnClick_Position[1,4] = "1 -3 2";//4
	MLRSShootOnClick_Velocity[1,4] = "10 -10 8";
	MLRSShootOnClick_Scale[1,4] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[1,4] = "0 0 0";

	MLRSshootOnClick_Spread[1,5] = 0.0;
	MLRSShootOnClick_Projectile[1,5] = MLRSSmokeProjectile;
	MLRSShootOnClick_Position[1,5] = "1 -3 2";//5
	MLRSShootOnClick_Velocity[1,5] = "0 -18 8";
	MLRSShootOnClick_Scale[1,5] = "1 1 1";
	MLRSShootOnClick_FlashVelocity[1,5] = "0 0 0";

};


function MLRSVehicle::onAdd(%this,%obj)
{
	// Setup the car with some defaults tires & springs
	// %obj.setWheelTire(0, %this.defaultTire);
	// %obj.setWheelSpring(1, %this.defaultSpring);

	for (%i = 0; %i < %this.numWheels; %i++)
	{

		%obj.setWheelTire(%i, %this.defaultTire);
		%obj.setWheelSpring(%i, %this.defaultSpring);
	}

	// 4 wheel steering
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	%obj.setWheelSteering(4,-1);
	%obj.setWheelSteering(5,-1);


	// 4 wheel drive
	%obj.setWheelPowered(0,true);
	%obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
	%obj.setWheelPowered(3,true);
	%obj.setWheelPowered(4,true);
	%obj.setWheelPowered(5,true);
	// turret
	%obj.turret = new AIPlayer()
	{
		dataBlock = MLRSTurretPlayer;
	};
	MissionCleanup.add(%obj.turret);
	%obj.mountObject(%obj.turret, 1);
	%obj.turret = %obj.turret;

	%obj.creationTime = getSimTime();
	%obj.turret.schedule(10,"rigTurret");
	%obj.mountimage(MLRSFrontTireStop,2);

	%obj.reloading = false;
	%obj.aLock = false;
	%obj.saveLock = "";
	%obj.turretDiffPos = "";
	%obj.ammo[0] = 12;
	%this.onTick(%obj,0);
}

function MLRSVehicle::GetBallisticAimPos(%this,%obj,%pos,%roundVel,%mortarAim,%gMod)
{
	%tank = %obj.getObjectMount();
	%posFlat = setWord(%pos,2,getWord(%tank.turret.getEyeTransform(),2));
	%x = VectorDist(%tank.turret.getEyeTransform(),%posFlat);
	%y = getWord(%pos,2) - getWord(%tank.turret.getEyeTransform(),2);

	%g = 9.81 * %gMod;
	%r1 = mSqrt(mPow(%roundVel,4) - %g * (%g * (%x * %x) + ( (2 * %y) * (%roundVel * %roundVel))));

	if (%r1 $= "-1.#IND" || %pos $= "") // If not a real number, it's not possible to hit %pos, return -1
		return "Out of Range";

	%a1 = ((%roundVel*%roundVel) - %r1) / (%g * %x);
	%a1 = mASin(%a1 / mSqrt((%a1 * %a1) + 1));
	%angleOfReach = mRadToDeg(%a1);
	if (%mortarAim)
		%angleOfReach = 90 - %angleOfReach;

	%offsetHeight = mTan(mDegToRad(%angleOfReach)) * %x;

	%ans = VectorAdd(%posFlat,"0 0 " @ %offsetHeight);


	return %ans;
}

function MLRSVehicle::getTurretAzimuth(%this,%obj)
{

	%eyePos = getWords(%obj.getEyeTransform(),0,2);
	%iPos= repeatedVectorAddwithScale(
	           %obj.getEyeVector() SPC 100 TAB
	           %obj.getLeftVector() SPC 0 TAB
	           %obj.getUpVector() SPC 0
	       );
	%slotPos = vectorAdd(%eyePos,%iPos);

	%posFlat = setWord(%slotPos,2,getWord(%eyePos,2));

	%a = vectorScale(vectorNormalize(vectorSub(%slotPos,%obj.getEyeTransform())),100);
	%b = vectorScale(vectorNormalize(vectorSub(%posFlat,%obj.getEyeTransform())),100);

	%num = vectorDot(%a,%b);
	%denom = VectorLen(%a) * VectorLen(%b);

	if (getWord(%slotPos,2) > getWord(%posFlat,2)) 
		%ans = mACos(%num/%denom) * 2;
	else
		%ans = mACos(%num/%denom) * -2;

	return mFloor(mRadtoDeg(%ans) * 10) / 10;
}

function MLRSVehicle::speedCheck(%this,%obj)
{
	%speed = vectorLen(%obj.getVelocity());
	if (%speed > 1)
	{
		%obj.unmountImage(2);
		%obj.mountimage(MLRSFrontTire,2);
	}
	else
	{
		%obj.unmountImage(2);
		%obj.mountimage(MLRSFrontTireStop,2);
	}
}

function MLRSVehicle::aimTurret(%this,%obj,%pt,%targetPos)
{
	%player = %obj.getMountNodeObject(0);
	%pOffset = "10000000000000 0 0";

	%pVec = repeatedVectorAddwithScale(
	            %player.getEyeVector() SPC getWord(%pOffset,0) TAB
	            %player.getLeftVector() SPC getWord(%pOffset,1) TAB
	            %player.getUpVector() SPC getWord(%pOffset,2)
	        );

	%pEyePos = vectorAdd(%targetPos,vectorScale(vectorSub(%targetPos,%obj.turret.getEyeTransform()),10000000000000));
	%tankRot = getWord(axisToEuler(%obj.getTransform()),2);
	%azimuth = getWord(axisToEuler(%obj.getTransform()),0);
	%obj.turretAzimuth = %this.getTurretAzimuth(%obj.turret);

	if (%pt) {
		%a = vectorSub(getWords(%obj.turret.getEyeTransform(),0,1) SPC 0,%pt);
		%b = vectorSub(getWords(%player.getEyeTransform(),0,1) SPC 0,%pt);

		%tPos = vectorNormalize(%obj.turret.getForwardVector());
		%pPos = vectorNormalize(%player.getForwardVector());
		%x =  getWord(%tPos,0) * getWord(%pPos,1) - getWord(%tPos,1) * getWord(%pPos,0);
		%dir = %x > 0 ? -1 : 1;
		%num = vectorDot(%a,%b);
		%denom = VectorLen(%a) * VectorLen(%b);
		%angleDiff = mRadtoDeg(mACos(%num/%denom)) * %dir;
	}
	%turretVec = getWords(rotateXYVector(%pEyePos,(%tankRot * -1) - %angleDiff),0,1) SPC (%azimuth*-20000) + getWord(rotateXYVector(%pEyePos,%tankRot),2);
	%obj.turret.setAimLocation(%turretVec);
}

function MLRSVehicle::onTick(%this,%obj,%i)
{
	if (isObject(%obj))
	{

		if (isObject(%obj.turret))
		{

			%this.speedCheck(%obj);
			
			if (isObject(%obj.getMountNodeObject(0)))
			{
				%player = %obj.getMountNodeObject(0);
				%errThreshold = 0.1;
				%colorFactor = 1;
				%scrollFactor = 1;
				
				
				%tmpDiffPos = %rayEnd;

				
				

				if (%obj.aLock)
				{
					%obj.textColor = "\c2";
					if (%obj.saveLock == 0) {
						%muzzlePoint = getWords(%player.getEyeTransform(),0,2);

						%raycast = containerRayCast(%muzzlePoint,VectorAdd(%muzzlePoint,VectorScale(%player.getEyeVector(),1000)), $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%player);
						%rayEnd = posFromRaycast(%raycast);
						%obj.saveLock = %rayEnd;
						%obj.coord = mFloor(getWord(%rayEnd,0)+0.5) SPC mFloor(getWord(%rayEnd,1)+0.5) SPC mFloor(getWord(%rayEnd,2)+0.5);
					}
					
					%tmpAngle = %this.GetBallisticAimPos(%obj.getMountNodeObject(0),%obj.saveLock, MLRSCannonStage1Projectile.muzzleVelocity, false, MLRSCannonStage1Projectile.gravityMod);
					if (%tmpAngle $= "Out of Range" || %obj.coord $= "0 0 0") {
						%obj.coord = "Out of Range";
						%obj.textColor = "\c3";
						%obj.aLock = false;
						%obj.saveLock = 0;
					}
					else
						%this.aimTurret(%obj,0,%tmpAngle);
					//%obj.saveLock
				}
				else
				{
					%obj.coord = "N/A";
					%obj.textColor = "\c0";
					%obj.turret.clearAim();
					%obj.turret.setTransform("0 0 0 0 0 0 0");
				}
				commandToclient(%obj.getMountedObject(0).client,'centerprint',
								"<just:center><font:Lucida Console:19pt>\n\n\n\n\n\c6[    ]"
				                ,1,2,3,4);

				commandToclient(%obj.getMountedObject(0).client,'bottomPrint',
				                "<just:left><font:Lucida Console:17pt>" @ %obj.textColor @ "[R]Target Coordinate:" SPC %obj.coord 
				                ,1,2,3,4);

		
			}
		}
		%i++;
		%this.schedule(400,onTick,%obj,%i);
	}
}

function Player::rigTurret(%obj)
{
	if (%obj.dataBlock !$= MLRSTurretPlayer)
		return;

	if (!isObject(%obj))
		return;

	%parent = %obj.getObjectMount();
	if (!isObject(%parent))
		return;

	%obj.spawnBrick = %parent.spawnBrick;
	%obj.brickGroup = %parent.brickGroup;
}

function MLRSVehicle::onRemove(%this,%obj)
{
	if (isObject(%obj.turret))
		%obj.turret.delete();
}

function MLRSTurretPlayer::onAdd(%this, %obj)
{
	%obj.lastShotTime = getSimTime() - 2000;
	Parent::onAdd(%this, %obj);
}

package MLRSPackage
{
	function serverCmdLight(%client)
	{


		%p = %client.player;
		if (!isobject(%p.getobjectmount()))
			return Parent::serverCmdLight(%client);



		if (%p.getobjectmount().getdatablock() == MLRSVehicle.getid())
		{
			%tank = %p.getobjectmount();
			if (%tank.aLock)
			{
				%tank.aLock = false;
				%tank.saveLock = "";
			}
			else
				%tank.aLock = true;
		}
		else
			Parent::serverCmdLight(%client);


	}
	function Player::burn(%obj,%time)
	{
		if (%obj.dataBlock $= MLRSTurretPlayer)
			return;
		else
			Parent::burn(%obj,%time);
	}

	function ShapeBase::setNodeColor(%obj,%node,%color)
	{
		Parent::setnodecolor(%obj,%node,%color);
		if (isObject(%obj.turret))
		{
			%obj.turret.setNodeColor("ALL",%color);
		}
	}

	function MLRSVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
	{
		if (%amm < 50) %amm = 0;
		if ((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
		{
			if (%obj.destroyed) return;
			%obj.setNodeColor("ALL","0 0 0 1");
			if (isObject(%obj.turret))  %obj.turret.delete();
			%p = new Projectile()
			{
				dataBlock = vehicleExplosionProjectile;
				initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
				initialVelocity = "0 0 1";
				client = %obj.lastDamageClient;
				sourceClient = %obj.lastDamageClient;
			};
			MissionCleanup.add(%p);
			if (%obj.destroyed) return;
			%obj.setDamageLevel(%this.maxDamage);
			%obj.destroyed = 1;
			%obj.schedule(%this.burnTime,"finalExplosion");
			if (isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
			%obj.spawnBrick.schedule(%respawn,"spawnVehicle");
		}
		else
			parent::Damage(%this,%obj,%source,%pos,%amm,%type);
	}
	function MLRSTurretPlayer::Damage(%this,%obj,%source,%pos,%amount,%type)
	{
		parent::Damage(%this,%obj,%source,%pos,0,%type);
	}
	function Player::emote(%obj,%emote)
	{
		if (%obj.dataBlock $= MLRSTurretPlayer)
			return;
		Parent::emote(%obj,%emote);
	}


	function MLRSTurretPlayer::onDisabled(%this,%obj,%state)
	{
		%tank = %obj.getObjectMount();
		if (isObject(%tank))
			%pos = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
		else
			%pos = %obj.getHackPosition();

		%p = new Projectile()
		{
			dataBlock = TankTurretExplosionProjectile;
			initialPosition = %pos;
			initialVelocity = "0 0 1";
			client = %obj.lastDamageClient;
			sourceClient = %obj.lastDamageClient;
		};
		MissionCleanup.add(%p);
		%obj.schedule(10,"delete");

		//mount the guy who was in the turret to the tank
		if (isObject(%tank))
		{
			%player = %obj.getMountedObject(0);
			if (isObject(%player))
			{
				%obj.getObjectMount().schedule(10,"mountObject",%player,1);
			}
		}

		if (!isObject(%tank))
		{
			if (isObject(%obj.spawnBrick))
			{
				%mg = getMiniGameFromObject(%obj);
				if (isObject(%mg))
				{
					%obj.spawnBrick.spawnVehicle(%mg.vehicleReSpawnTime);
				}
				else
				{
					%obj.spawnBrick.spawnVehicle(0);
				}
			}

			Parent::onDisabled(%this,%obj,%state);
		}
	}

	function MLRSTurretPlayer::Damage(%data,%obj,%source,%pos,%amm,%type)
	{
		//scale the damage ammount as if this was a vehicle
		%amm *= $Damage::VehicleDamageScale[%type];

		if (%obj.getDamageLevel()+%amm > %data.maxDamage && !isObject(%obj.client))
			%obj.setDamageLevel(%data.maxDamage);
		else
			Parent::Damage(%data,%obj,%source,%pos,%amm,%type);
	}

	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if (%col.getDataBlock() == MLRSVehicle.getId())
		{
			%obj.setLookLimits(1,0);

		}

	}
	function Projectile::onAdd(%obj,%a,%b)
	{
	   if(%obj.dataBlock.getID() == MLRSCannonStage1Projectile.getID())
	   {
	   	%obj.schedule(getRandom(4000,5000),spawnStage2);
	   }

	   Parent::onAdd(%obj,%a,%b);
	}
};

function Projectile::spawnStage2(%this)
{
	if(!isObject(%this.client))
      return;
   
   	if(!isObject(%this) || vectorLen(%this.getVelocity()) == 0)
      return;
	%p = new Projectile()
	{
		dataBlock = MLRSCannonStage2Projectile;
		initialPosition = %this.getPosition();
		initialVelocity = %this.getVelocity();
		sourceObject = %this.sourceObject;
		client = %this.client;
	};

	if(isObject(%p)) {
		MissionCleanup.add(%p);
		%p.setScale(%this.getScale());
		%this.delete();
	}
}
activatepackage(MLRSPackage);

function repeatedVectorAddwithScale(%vecs)
{
	%vec="0 0 0";
	%cnt=getFieldCount(%vecs);
	for (%i=0; %i<%cnt; %i++)
	{
		%fld=getField(%vecs,%i);
		%tvec=getWords(%fld,0,3);
		%scale=getWord(%fld,3);
		%svec=vectorScale(%tvec,%scale);
		%vec=vectorAdd(%vec,%svec);
	}
	return %vec;
}

function SimObject::getLeftVector(%obj)
{
	return vectorCross(%obj.getEyeVector(),%obj.getUpVector());
}

function SimObject::getRightVector(%obj)
{
	return vectorScale(%obj.getLeftVector(%obj),-1);
}

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,6) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,3) * %sinThetaOver2;
	%q2 = getWord(%axis,4) * %sinThetaOver2;
	%q3 = getWord(%axis,5) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
function rotateXYVector(%v,%t)
{
	%x = getWord(%v,0);
	%y = getWord(%v,1);
	%z = getWord(%v,2);
	return (   %x * mCos(%t * ($pi/180)) - %y * mSin(%t * ($pi/180))  ) SPC (   %y * mCos(%t * ($pi/180)) + %x * mSin(%t * ($pi/180)) SPC %z );
}
function rgbToHex( %rgb )
{
	%r = _compToHex( getWord( %rgb, 0 ) );
	%g = _compToHex( getWord( %rgb, 1 ) );
	%b = _compToHex( getWord( %rgb, 2 ) );
	%ans = %r @ %g @ %b;
	return %ans;
}
function _compToHex( %comp )
{
	%left = mFloor( %comp / 16 );
	%comp = mFloor( %comp - %left * 16 );

	%left = getSubStr( "0123456789ABCDEF", %left, 1 );
	%comp = getSubStr( "0123456789ABCDEF", %comp, 1 );

	return %left @ %comp;
}